#include <syslog.h>
#include <netinet/in.h>
#include "config.h"

void ylog (unsigned int code,
		unsigned int pos,
		unsigned int poc,
		struct in_addr *addin)
{
	switch (code) {
		case 1: syslog(LOG_ERR | LOG_DAEMON,
				"X,X:%s:FAIL:send fallback reply\n",
				inet_ntoa(*addin));
			break;
		case 2: syslog(LOG_ERR | LOG_DAEMON,
				"%u,%u:%s:FAIL:compose invalid port reply\n",
				pos, poc, inet_ntoa(*addin));
			break;
		case 3: syslog(LOG_ERR | LOG_DAEMON,
				"%u,%u:%s:FAIL:send invalid port reply\n",
				pos, poc, inet_ntoa(*addin));
			break;
		case 4: syslog(LOG_ERR | LOG_DAEMON,
				"%u,%u:%s:FAIL:compose no uid reply\n",
				pos, poc, inet_ntoa(*addin));
			break;
		case 5: syslog(LOG_ERR | LOG_DAEMON,
				"%u,%u:%s:FAIL:send no uid reply\n",
				pos, poc, inet_ntoa(*addin));
			break;
		case 6: syslog(LOG_ERR | LOG_DAEMON,
				"%u,%u:%s:FAIL:compose no user reply\n",
				pos, poc, inet_ntoa(*addin));
			break;
		case 7: syslog(LOG_ERR | LOG_DAEMON,
				"%u,%u:%s:FAIL:send unknown error reply\n",
				pos, poc, inet_ntoa(*addin));
			break;
		case 8: syslog(LOG_ERR | LOG_DAEMON,
				"%u,%u:%s:FAIL:compose unknown error reply\n",
				pos, poc, inet_ntoa(*addin));
			break;
		case 9: syslog(LOG_ERR | LOG_DAEMON,
				"%u,%u:%s:FAIL:compose successful reply\n",
				pos, poc, inet_ntoa(*addin));
			break;
		case 10: syslog(LOG_ERR | LOG_DAEMON,
				"%u,%u:%s:FAIL:send successful reply\n",
				pos, poc, inet_ntoa(*addin));
			 break;
		case 11: syslog(LOG_ERR | LOG_DAEMON,
				"X,X:%s:FAIL:b0rked recv() call\n",
				inet_ntoa(*addin));
			 break;
		case 12: syslog(LOG_ERR | LOG_DAEMON,
				"x,x:%s:FAIL:query not digit , digit form\n",
				inet_ntoa(*addin));
			 break;
		case 13: syslog(LOG_ERR | LOG_DAEMON,
				"%u,%u:%s:FAIL:query on invalid port number\n",
				pos, poc, inet_ntoa(*addin));
			 break;
		case 14: syslog(LOG_ERR | LOG_DAEMON,
				"%u,%u:%s:SUCC:uid lookup\n",
				pos, poc, inet_ntoa(*addin));
			 break;
		case 15: syslog(LOG_ERR | LOG_DAEMON,
				"%u,%u:%s:SUCC:username lookup from uid\n",
				pos, poc, inet_ntoa(*addin));
			 break;
		case 16: syslog(LOG_ERR | LOG_DAEMON,
				"%u,%u:%s:SUCC:response composition\n",
				pos, poc, inet_ntoa(*addin));
			 break;
		case 17: syslog(LOG_ERR | LOG_DAEMON,
				"%u,%u:%s:SUCC:compliant query response\n",
				pos, poc, inet_ntoa(*addin));
			 break;
		case 18: syslog(LOG_ERR | LOG_DAEMON,
				"X,X:%s:SUCC:fallback query response\n",
				inet_ntoa(*addin));
			 break;
		case 19: syslog(LOG_ERR | LOG_DAEMON,
				"%u,%u:%s:SUCC:Invalid port response\n",
				pos, poc, inet_ntoa(*addin));
			 break;
		case 20: syslog(LOG_ERR | LOG_DAEMON,
				"%u,%u:%s:INFO:uid lookup crash n' burn\n",
				pos, poc, inet_ntoa(*addin));
			 break;
		case 21: syslog(LOG_ERR | LOG_DAEMON,
				"%u,%u:%s:SUCC:no user response\n",
				pos, poc, inet_ntoa(*addin));
			 break;
		case 22: syslog(LOG_ERR | LOG_DAEMON,
				"%u,%u:%s:FAIL:Username lookup (Bad.)\n",
				pos, poc, inet_ntoa(*addin));
			 break;
		case 23: syslog(LOG_ERR | LOG_DAEMON,
				"%u,%u:%s:SUCC:UNKNOWN-ERROR reply\n",
				pos, poc, inet_ntoa(*addin));
			 break;
		case 24: syslog(LOG_ERR | LOG_INFO,
				"%u,%u:%s:SUCC:Fetch spoofed username\n");
			 break;
	}
}
