#include <stdio.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <stdlib.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <signal.h>
#include <syslog.h>
#include <dlfcn.h> /* for dynamic loading of modules */

#include "config.h"
#include "respond.h"
#include "parseconf.h"

#define LCL_PORT 113
#define BACKLOG   10
#define TIMEOUT  180

void sig_alarm_handler(int unused);

void sigchld_handler(int s)
{
	while (wait(NULL) > 0);
}

struct options bowman;

int main (int argc, char *argv[])
{
	int sockfd, newfd;
	struct sockaddr_in my_addr, their_addr;
	int yes = 1;
	int zin_size;
	unsigned long faddr;
	struct sigaction sa;
	void *parseconf_handle;
	int (*conf_fcn)(); /* pointer to parseconf() inside the .so file */
	const char *dlsym_return;

	zin_size = sizeof(struct sockaddr_in);

	parseconf_handle = dlopen("parseconf.so", RTLD_NOW);
	if (parseconf_handle == NULL) {
		/* ERRORHANDLER */
		perror("Fucking A!");
		exit(EXIT_FAILURE);
	}
	conf_fcn = dlsym(parseconf_handle, "parseconf");
	if ((dlsym_return = dlerror()) != NULL) {
		/* ERRORHANDLER */
		/* function name not found in .so file */
		exit(EXIT_FAILURE);
	}
	
	if (conf_fcn(&bowman) != 0) {
		/* ERRORHANDLER */
		/* parseconf() failed */
		exit(EXIT_FAILURE);
	}
	
	dlclose(parseconf_handle);

	if (daemon(0,0) != 0) {
		// ERRORHANDLER 
		exit(EXIT_FAILURE);
	}
	if (signal(SIGALRM, sig_alarm_handler) == SIG_ERR) {
		/* ERRORHANDLER */
	}
	
	if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
		/* ERRORHANDLER 01*/
		exit(EXIT_FAILURE);
	}

	if ((setsockopt(sockfd,SOL_SOCKET,SO_REUSEADDR,
					&yes,sizeof(int))) == -1) {
		/* ERRORHANDLER */
		exit(EXIT_FAILURE);
	}

	my_addr.sin_family = AF_INET;
	my_addr.sin_port = htons(LCL_PORT);
	my_addr.sin_addr.s_addr = INADDR_ANY;
	memset(&(my_addr.sin_zero), '\0', 8);

	if ((bind(sockfd,(struct sockaddr*)&my_addr,
			  sizeof(struct sockaddr))) == -1) {
		/* ERRORHANDLER */
		exit(EXIT_FAILURE);
	}

	if ((listen(sockfd, BACKLOG)) == -1) {
		/* ERRORHANDLER */
		exit(EXIT_FAILURE);
	}

	/* TODO understand this bit better; splint is coughs here */
	sa.sa_handler = sigchld_handler;
	sigemptyset(&sa.sa_mask);
	sa.sa_flags = SA_RESTART;
	if (sigaction(SIGCHLD, &sa, NULL) == -1) {
		/* ERRORHANDLER */
		exit(EXIT_FAILURE);
	}


	
	while (TRUE) {   /* main accept loop */
		if ((newfd = accept(sockfd,
				   (struct sockaddr *) &their_addr,
				   (socklen_t *) &zin_size)) == -1) {
			/* ERRORHANDLER */
			exit(EXIT_FAILURE);
		}
		

		faddr = their_addr.sin_addr.s_addr;
		
		if (fork() == 0) {
			if (close(sockfd) != 0) {
				/* ERRORHANDLER */
				exit(EXIT_FAILURE);
			}
			if (alarm(TIMEOUT) < 0) { /* can this ever happen? */
				/* ERRORHANDLER */
				exit(EXIT_FAILURE);
			}
			if (service_request(newfd, faddr, &bowman) != 0) {
				/* ERRORHANDLER */
				exit(EXIT_FAILURE);
			}
			exit(EXIT_SUCCESS);
		} else {
			if (close(newfd) != 0) {
				/* ERRORHANDLER */
				exit(EXIT_FAILURE);
			}
		}
		if (close(newfd) !=0) {
			/* ERRORHANDLER */
		// 	exit(EXIT_FAILURE);
		}


	}

}	



void sig_alarm_handler(int unused)
{
	exit(EXIT_SUCCESS);
	// (void) unused;   WTF does this do? Did it do anything useful?
	// splint didn't like it, and besides, I mean, it comes
	// after a frigging return()...
}
